package speiger.src.coreengine.rendering.newGui.layout;

import speiger.src.coreengine.rendering.gui.helper.box.IGuiBox;
import speiger.src.coreengine.rendering.newGui.layout.IConstraint.ISimpleConstraint;

public class Constraints {
	public static record Pixels(float value, boolean inverted) implements ISimpleConstraint {
		
		public static Pixels of(float value) { return new Pixels(value, false); }
		public static Pixels inverted(float value) { return new Pixels(value, true); }
		
		@Override
		public void apply(IGuiBox owner, IGuiBox parent, Target target) {
			target.set(owner, inverted ? target.asArea().get(parent) - value : value);
		}
	}
	
	public static record Parent(float padding, boolean inv) implements ISimpleConstraint {
		
		public static Parent of() { return new Parent(0F, false); }
		public static Parent of(float padding) { return new Parent(padding, false); }
		public static Parent inverted() { return new Parent(0F, true); }
		public static Parent inverted(float padding) { return new Parent(padding, true); }
		
		@Override
		public void apply(IGuiBox owner, IGuiBox parent, Target target) {
			//TODO implement
		}
	}
}
